## pylsqpack 0.3.18

=== vendor/ls-qpack/CMakeLists.txt ===
# The following variable can be defined on the command line:
#
#   BUILD_SHARED_LIBS
#
# The following environment variables will be taken into account when running
# cmake for the first time:
#
#   CFLAGS
#   LDFLAGS

cmake_minimum_required(VERSION 3.1)
project(ls-qpack LANGUAGES C)

option(LSQPACK_TESTS "Build tests")
option(LSQPACK_BIN "Build binaries" ON)
option(LSQPACK_XXH "Include XXH" ON)

# Use `cmake -DBUILD_SHARED_LIBS=OFF` to build a static library.
add_library(ls-qpack "")
target_include_directories(ls-qpack PUBLIC .)
target_sources(ls-qpack PRIVATE lsqpack.c)

target_include_directories(ls-qpack PRIVATE deps/xxhash/)
if(LSQPACK_XXH)
    target_sources(ls-qpack PRIVATE deps/xxhash/xxhash.c)
endif()

if(MSVC)
    target_include_directories(ls-qpack PUBLIC wincompat)
endif()

if(MSVC)
    target_compile_options(ls-qpack PRIVATE
        /Wall
        /wd4100 # unreffed parameter
        /wd4200 # zero-sized array
        # Apparently this C99 construct is not supported properly by VS:
        #   https://stackoverflow.com/questions/1064930/struct-initializer-typedef-with-visual-studio
        /wd4204 # non-constant aggregate initializer
        /wd4255 # no function prototype (getopt)
        /wd4820 # padding
        /wd4668 # undefined macro
        /wd4710 # not inlined by default
        /wd4996 # unsafe function
    )
else()
    target_compile_options(ls-qpack PRIVATE
        -Wall
        -Wextra
        -Wno-unused-parameter
        -fno-omit-frame-pointer
    )
endif()

IF (CMAKE_BUILD_TYPE STREQUAL MinSizeRel)
    SET(CMAKE_C_FLAGS "${CMAKE_C_CFLAGS} -DLS_QPACK_USE_LARGE_TABLES=0")
ENDIF()

if(LSQPACK_TESTS)
    enable_testing()
    add_subdirectory(test)
endif()

if(LSQPACK_BIN)
    add_subdirectory(bin)
endif()

=== vendor/ls-qpack/bin/CMakeLists.txt ===
function(lsqpack_add_executable TARGET)
    add_executable(${TARGET} "")
    target_link_libraries(${TARGET} PRIVATE ls-qpack)

    target_sources(${TARGET} PRIVATE ${TARGET}.c)

    if(MSVC)
        target_include_directories(${TARGET} PRIVATE ../wincompat)
        target_sources(${TARGET} PRIVATE 
            ../wincompat/getopt.c 
            ../wincompat/getopt1.c
        )
    else()
        target_link_libraries(${TARGET} PRIVATE m)
    endif()
endfunction()

lsqpack_add_executable(interop-encode)
lsqpack_add_executable(interop-decode)
lsqpack_add_executable(encode-int)
lsqpack_add_executable(fuzz-decode)

## pylsqpack 0.3.17

=== debian/changelog ===
pylsqpack (0.3.17-2) unstable; urgency=medium

  * Correct Vcs* and upload to unstable so binaries are built on buildd

 -- Scott Kitterman <scott@kitterman.com>  Wed, 26 Jul 2023 21:44:39 -0400

pylsqpack (0.3.17-1) unstable; urgency=low

  * Initial release, (Closes: #1040553)
  * Patch out privacy related cruft in documentation

 -- Scott Kitterman <scott@kitterman.com>  Tue, 25 Jul 2023 23:34:41 -0400

=== debian/control ===
Source: pylsqpack
Section: python
Priority: optional
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders: Scott Kitterman <scott@kitterman.com>
Build-Depends: debhelper-compat (= 13),
               pybuild-plugin-pyproject, python3-setuptools,
               python3-all-dev,
               python3-sphinx,
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/python-team/packages/pylsqpack.git
Vcs-Browser: https://salsa.debian.org/python-team/packages/pylsqpack
Testsuite: autopkgtest-pkg-pybuild
Rules-Requires-Root: no

Package: python3-pylsqpack
Architecture: any
Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends},
Suggests: python-pylsqpack-doc
Description: Python wrapper for the ls-qpack QPACK library
 Wrapper around the ls-qpack library. It provides Python Decoder and Encoder
 objects to read or write HTTP/3 headers compressed with QPACK.

Package: python-pylsqpack-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Description: documentation for the pylsqpack Python library
 This package provides documentation for python3-pylsqpack

=== debian/rules ===
#! /usr/bin/make -f

export PYBUILD_NAME=pylsqpack
%:
	dh $@ --with python3,sphinxdoc --buildsystem=pybuild

execute_after_dh_auto_build-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	cd docs && \
	PYTHONPATH=$(CURDIR) http_proxy='http://127.0.0.1:9/' https_proxy='https://127.0.0.1:9/' \
	sphinx-build -N -E -T -b html . $(CURDIR)/.pybuild/docs/html/
	rm -rf $(CURDIR)/.pybuild/docs/html/.doctrees
endif

## pylsqpack 0.3.18

=== debian/changelog ===
pylsqpack (0.3.18-1) unstable; urgency=medium

  [Dale Richards]
  * Modify d/rules and patch setup.py to build the included C libraries using
    the compiler flags recommended by Debian Hardening.

  [Scott Kitterman]
  * Set Multi-Arch: foreign in python-pylsqpack-doc
  * Update d/source/options extend-diff-ignore to prevent python package
    metadata regeneration from preventing source package rebuilding (Closes:
    #1047662)
  * In d/control, add Homepage field and update python-pylsqpack-doc long
    description to include primary package description
  * New upstream release

 -- Scott Kitterman <scott@kitterman.com>  Sat, 30 Dec 2023 16:39:10 -0500

=== debian/control ===
--- 
+++ 
@@ -10,6 +10,7 @@
 Standards-Version: 4.6.2
 Vcs-Git: https://salsa.debian.org/python-team/packages/pylsqpack.git
 Vcs-Browser: https://salsa.debian.org/python-team/packages/pylsqpack
+Homepage: https://github.com/aiortc/pylsqpack
 Testsuite: autopkgtest-pkg-pybuild
 Rules-Requires-Root: no
 
@@ -24,6 +25,10 @@
 Package: python-pylsqpack-doc
 Section: doc
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}, ${sphinxdoc:Depends}
 Description: documentation for the pylsqpack Python library
- This package provides documentation for python3-pylsqpack 
+ Wrapper around the ls-qpack library. It provides Python Decoder and Encoder
+ objects to read or write HTTP/3 headers compressed with QPACK.
+ .
+ This package provides documentation for python3-pylsqpack.

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,6 @@
 #! /usr/bin/make -f
+
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 export PYBUILD_NAME=pylsqpack
 %:

## pylsqpack 0.3.22

=== docs/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
SPHINXPROJ    = pylsqpack
SOURCEDIR     = .
BUILDDIR      = _build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== vendor/ls-qpack/CMakeLists.txt ===
--- 
+++ 
@@ -9,24 +9,49 @@
 #   LDFLAGS
 
 cmake_minimum_required(VERSION 3.1)
-project(ls-qpack LANGUAGES C)
+project(ls-qpack 
+	LANGUAGES C
+        HOMEPAGE_URL "https://github.com/litespeedtech/ls-qpack"
+        DESCRIPTION "QPACK compression library for use with HTTP/3" 
+        VERSION 2.6.1)
 
 option(LSQPACK_TESTS "Build tests")
 option(LSQPACK_BIN "Build binaries" ON)
 option(LSQPACK_XXH "Include XXH" ON)
+option(BUILD_SHARED_LIBS OFF)
 
 # Use `cmake -DBUILD_SHARED_LIBS=OFF` to build a static library.
 add_library(ls-qpack "")
-target_include_directories(ls-qpack PUBLIC .)
+add_library(ls-qpack::ls-qpack ALIAS ls-qpack)
+set_target_properties(ls-qpack PROPERTIES
+	VERSION ${PROJECT_VERSION}
+	SOVERSION ${PROJECT_VERSION_MAJOR})
+target_include_directories(ls-qpack PUBLIC 
+    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
+    $<INSTALL_INTERFACE:include>
+)
 target_sources(ls-qpack PRIVATE lsqpack.c)
 
-target_include_directories(ls-qpack PRIVATE deps/xxhash/)
 if(LSQPACK_XXH)
+    target_include_directories(ls-qpack PRIVATE deps/xxhash/)
     target_sources(ls-qpack PRIVATE deps/xxhash/xxhash.c)
+    set(LSQPACK_DEPENDS "")
+else()
+    find_package(xxHash CONFIG)
+    if(NOT xxHash_FOUND)
+        find_package(PkgConfig REQUIRED)
+        pkg_check_modules(LS_QPACK_XXH REQUIRED IMPORTED_TARGET libxxhash GLOBAL)
+        add_library(xxHash::xxhash ALIAS PkgConfig::LS_QPACK_XXH)
+    endif()
+    target_link_libraries(ls-qpack PRIVATE xxHash::xxhash)
+    set(LSQPACK_DEPENDS "libxxhash")
 endif()
 
-if(MSVC)
-    target_include_directories(ls-qpack PUBLIC wincompat)
+if(WIN32 OR EMSCRIPTEN)
+    target_include_directories(ls-qpack PUBLIC
+        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/wincompat>
+        $<INSTALL_INTERFACE:include>
+    )
 endif()
 
 if(MSVC)
@@ -38,10 +63,13 @@
         #   https://stackoverflow.com/questions/1064930/struct-initializer-typedef-with-visual-studio
         /wd4204 # non-constant aggregate initializer
         /wd4255 # no function prototype (getopt)
+        /wd4334 # result of 32-bit shift implicitly converted to 64 bits
         /wd4820 # padding
         /wd4668 # undefined macro
         /wd4710 # not inlined by default
         /wd4996 # unsafe function
+        /wd4061 # enum is not explicitly handled by a case
+        /wd5045 # Compiler will insert Spectre mitigation for memory load
     )
 else()
     target_compile_options(ls-qpack PRIVATE
@@ -52,9 +80,43 @@
     )
 endif()
 
+IF (CMAKE_SYSTEM_NAME STREQUAL Windows)
+    IF (LSQPACK_TESTS OR LSQPACK_BIN)
+        FIND_PATH(GETOPT_INCLUDE_DIR NAMES getopt.h)
+        IF (GETOPT_INCLUDE_DIR)
+            INCLUDE_DIRECTORIES(${GETOPT_INCLUDE_DIR})
+        ELSE()
+            MESSAGE(FATAL_ERROR "getopt.h was not found")
+        ENDIF()
+            FIND_LIBRARY(GETOPT_LIB getopt)
+        IF(GETOPT_LIB)
+            MESSAGE(STATUS "Found getopt: ${GETOPT_LIB}")
+        ELSE()
+            MESSAGE(STATUS "getopt not found")
+        ENDIF()
+    ENDIF()
+ENDIF()
+
+IF(DEFINED LSXPACK_MAX_STRLEN)
+    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DLSXPACK_MAX_STRLEN=${LSXPACK_MAX_STRLEN}")
+ENDIF()
+
 IF (CMAKE_BUILD_TYPE STREQUAL MinSizeRel)
-    SET(CMAKE_C_FLAGS "${CMAKE_C_CFLAGS} -DLS_QPACK_USE_LARGE_TABLES=0")
+    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DLS_QPACK_USE_LARGE_TABLES=0")
 ENDIF()
+
+IF(LSQPACK_TESTS)
+    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DLSQPACK_DEVEL_MODE=1")
+ENDIF()
+
+INCLUDE(CheckCCompilerFlag)
+CHECK_C_COMPILER_FLAG(-Wno-implicit-fallthrough HAS_NO_IMPLICIT_FALLTHROUGH)
+IF (HAS_NO_IMPLICIT_FALLTHROUGH)
+    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-implicit-fallthrough")
+ENDIF()
+
+SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} $ENV{EXTRA_CFLAGS}")
+MESSAGE(STATUS "Compiler flags: ${CMAKE_C_FLAGS}")
 
 if(LSQPACK_TESTS)
     enable_testing()
@@ -64,3 +126,35 @@
 if(LSQPACK_BIN)
     add_subdirectory(bin)
 endif()
+
+include(GNUInstallDirs)
+configure_file(lsqpack.pc.in lsqpack.pc @ONLY)
+install(FILES "${CMAKE_CURRENT_BINARY_DIR}/lsqpack.pc"
+    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
+
+configure_file(ls-qpack-config.cmake.in ls-qpack-config.cmake @ONLY)
+install(TARGETS ls-qpack EXPORT ls-qpack-config
+        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
+install(FILES "${CMAKE_CURRENT_BINARY_DIR}/ls-qpack-config.cmake"
+    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/ls-qpack)
+install(
+    EXPORT ls-qpack-config
+    FILE ls-qpack-targets.cmake
+    NAMESPACE ls-qpack::
+    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/ls-qpack
+)
+install(FILES lsqpack.h lsxpack_header.h
+	DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
+
+if(LSQPACK_BIN)
+    install(TARGETS
+            encode-int
+            fuzz-decode
+            interop-decode
+            interop-encode
+            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
+endif()
+
+if(WIN32 OR EMSCRIPTEN)
+    install(DIRECTORY wincompat/sys DESTINATION include)
+endif()

=== vendor/ls-qpack/bin/CMakeLists.txt ===
function(lsqpack_add_executable TARGET)
    add_executable(${TARGET} "")
    target_link_libraries(${TARGET} PRIVATE ls-qpack)

    if(LSQPACK_XXH)
        target_sources(${TARGET} PRIVATE ${TARGET}.c ../deps/xxhash/xxhash.c)
        target_include_directories(${TARGET} PRIVATE ../deps/xxhash)
    else()
        target_sources(${TARGET} PRIVATE ${TARGET}.c)
        target_link_libraries(${TARGET} PUBLIC xxHash::xxhash)
    endif()

    if(WIN32)
        target_include_directories(${TARGET} PRIVATE ../wincompat)
        target_link_libraries(${TARGET} PRIVATE ${GETOPT_LIB})
    else()
        target_link_libraries(${TARGET} PRIVATE m)
    endif()
endfunction()

lsqpack_add_executable(interop-encode)
lsqpack_add_executable(interop-decode)
lsqpack_add_executable(encode-int)
lsqpack_add_executable(fuzz-decode)

target_include_directories(interop-decode PRIVATE ../test)

=== vendor/ls-qpack/test/CMakeLists.txt ===
function(lsqpack_add_test TARGET)
    add_executable(test_${TARGET} "")
    target_sources(test_${TARGET} PRIVATE test_${TARGET}.c)
    target_link_libraries(test_${TARGET} ls-qpack)

    if(WIN32)
        target_include_directories(test_${TARGET} PRIVATE ../wincompat)
        target_link_libraries(test_${TARGET} ${GETOPT_LIB})
    else()
        target_link_libraries(test_${TARGET} m)
    endif()

    add_test(${TARGET} test_${TARGET})
endfunction()

lsqpack_add_test(int)
lsqpack_add_test(enc_str)
lsqpack_add_test(huff_dec)
lsqpack_add_test(read_enc_stream)
lsqpack_add_test(qpack)
lsqpack_add_test(circ_list)
lsqpack_add_test(dec_crash_case)
lsqpack_add_test(dyn_table_cap_mismatch)

if(WIN32)
    message(WARNING "Scenario tests are disabled on Windows (TODO)")
else()
    file(GLOB SCENARIOS scenarios/*.sce)
    foreach(SCENARIO ${SCENARIOS})
        get_filename_component(TEST_NAME ${SCENARIO} NAME)
        add_test(
            NAME scenario-${TEST_NAME}
            COMMAND bash run-scenario.sh ${SCENARIO}
            WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/test
        )
        set_tests_properties(scenario-${TEST_NAME} PROPERTIES
            ENVIRONMENT "PATH=$ENV{PATH}:${PROJECT_BINARY_DIR}/bin:${PROJECT_SOURCE_DIR}/tools"
        )
    endforeach()
endif()

find_package(Perl)

if(PERL_FOUND)
    message(STATUS "Found Perl interpreter: ${PERL_EXECUTABLE}")
    file(GLOB QIFS qifs/*.qif)
    
    foreach(QIF ${QIFS})
        get_filename_component(FILE_NAME ${QIF} NAME)
        
        foreach(TABLE_SIZE 0 256 512 1024 4096)
            foreach(RISKED_STREAMS 0 100)
                foreach(IMMEDIATE_ACK 0 1)
                    foreach(AGGRESSIVE 0 1)
                        set(TEST_NAME qif-${FILE_NAME}-t${TABLE_SIZE}-s${RISKED_STREAMS}-a${IMMEDIATE_ACK}-A${AGGRESSIVE})
                        
                        add_test(
                            NAME ${TEST_NAME}
                            COMMAND ${PERL_EXECUTABLE} run-qif.pl --table-size ${TABLE_SIZE} --risked-streams ${RISKED_STREAMS} --immed-ack ${IMMEDIATE_ACK} --aggressive ${AGGRESSIVE} ${QIF}
                            WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/test
                        )
                        
                        if(NOT WIN32)
                            set_tests_properties(${TEST_NAME} PROPERTIES
                                ENVIRONMENT "PATH=$ENV{PATH}:${PROJECT_BINARY_DIR}/bin:${PROJECT_SOURCE_DIR}/tools"
                            )
                        endif()
                    endforeach()
                endforeach()
            endforeach()
        endforeach()
    endforeach()
else()
    message(WARNING "Perl not found: QIF tests won't be run")
endif()

=== debian/changelog ===
pylsqpack (0.3.22-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * debian/copyright: Fix Upstream-Contact and Source fields.

 -- Colin Watson <cjwatson@debian.org>  Tue, 19 Aug 2025 15:22:01 +0100

pylsqpack (0.3.18-2) unstable; urgency=medium

  * Team upload.
  * Fix endianness issue on pylsqpack in s390x (thanks, Pranav P; closes:
    #1099935).
  * Use dh-sequence-python3 and dh-sequence-sphinxdoc.

 -- Colin Watson <cjwatson@debian.org>  Thu, 20 Mar 2025 23:22:24 +0000

=== debian/control ===
--- 
+++ 
@@ -4,8 +4,11 @@
 Maintainer: Debian Python Team <team+python@tracker.debian.org>
 Uploaders: Scott Kitterman <scott@kitterman.com>
 Build-Depends: debhelper-compat (= 13),
-               pybuild-plugin-pyproject, python3-setuptools,
+               dh-sequence-python3,
+               dh-sequence-sphinxdoc,
+               pybuild-plugin-pyproject,
                python3-all-dev,
+               python3-setuptools,
                python3-sphinx,
 Standards-Version: 4.6.2
 Vcs-Git: https://salsa.debian.org/python-team/packages/pylsqpack.git

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 export PYBUILD_NAME=pylsqpack
 %:
-	dh $@ --with python3,sphinxdoc --buildsystem=pybuild
+	dh $@ --buildsystem=pybuild
 
 execute_after_dh_auto_build-indep:
 ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))

## pylsqpack 0.3.23

=== debian/changelog ===
pylsqpack (0.3.23-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Drop "Rules-Requires-Root: no", default as of dpkg-dev 1.22.13.

 -- Colin Watson <cjwatson@debian.org>  Mon, 24 Nov 2025 16:37:33 +0000

=== debian/control ===
--- 
+++ 
@@ -15,7 +15,6 @@
 Vcs-Browser: https://salsa.debian.org/python-team/packages/pylsqpack
 Homepage: https://github.com/aiortc/pylsqpack
 Testsuite: autopkgtest-pkg-pybuild
-Rules-Requires-Root: no
 
 Package: python3-pylsqpack
 Architecture: any
